<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">SDL.GPU.Simple.RendererControls</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Int</span></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Word</span></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Ptr</span></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Storable</span></span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Marshal.Alloc</span></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad.IO.Class</span></span><span>
</span><span id="line-9"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Linear.V2</span></span><span>
</span><span id="line-10"></span><span>
</span><span id="line-11"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.C.html"><span class="hs-identifier">SDL.GPU.C</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">GPU</span></span><span>
</span><span id="line-12"></span><span>
</span><span id="line-13"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#reserveNextRendererEnum"><span class="hs-identifier hs-type">reserveNextRendererEnum</span></a></span><span>
</span><span id="line-14"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190752"><span class="annot"><a href="#local-6989586621679190752"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-15"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190752"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-16"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190752"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#RendererEnum"><span class="hs-identifier hs-type">GPU.RendererEnum</span></a></span><span>
</span><span id="line-17"></span><span id="reserveNextRendererEnum"><span class="annot"><span class="annottext">reserveNextRendererEnum :: forall (m :: * -&gt; *). MonadIO m =&gt; m RendererEnum
</span><a href="SDL.GPU.Simple.RendererControls.html#reserveNextRendererEnum"><span class="hs-identifier hs-var hs-var">reserveNextRendererEnum</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO RendererEnum
</span><a href="SDL.GPU.C.RendererControls.html#reserveNextRendererEnum"><span class="hs-identifier hs-var">GPU.reserveNextRendererEnum</span></a></span><span>
</span><span id="line-18"></span><span>
</span><span id="line-19"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#getNumActiveRenderers"><span class="hs-identifier hs-type">getNumActiveRenderers</span></a></span><span>
</span><span id="line-20"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190746"><span class="annot"><a href="#local-6989586621679190746"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-21"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190746"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-22"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190746"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Int"><span class="hs-identifier hs-type">GPU.Int</span></a></span><span>
</span><span id="line-23"></span><span id="getNumActiveRenderers"><span class="annot"><span class="annottext">getNumActiveRenderers :: forall (m :: * -&gt; *). MonadIO m =&gt; m Int
</span><a href="SDL.GPU.Simple.RendererControls.html#getNumActiveRenderers"><span class="hs-identifier hs-var hs-var">getNumActiveRenderers</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO Int
</span><a href="SDL.GPU.C.RendererControls.html#getNumActiveRenderers"><span class="hs-identifier hs-var">GPU.getNumActiveRenderers</span></a></span><span>
</span><span id="line-24"></span><span>
</span><span id="line-25"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#getActiveRendererList"><span class="hs-identifier hs-type">getActiveRendererList</span></a></span><span>
</span><span id="line-26"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190743"><span class="annot"><a href="#local-6989586621679190743"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-27"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190743"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-28"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#RendererID"><span class="hs-identifier hs-type">GPU.RendererID</span></a></span><span> </span><span class="hs-comment">-- ^ renderers_array</span><span>
</span><span id="line-29"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190743"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-30"></span><span id="getActiveRendererList"><span class="annot"><span class="annottext">getActiveRendererList :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr RendererID -&gt; m ()
</span><a href="SDL.GPU.Simple.RendererControls.html#getActiveRendererList"><span class="hs-identifier hs-var hs-var">getActiveRendererList</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr RendererID -&gt; IO ()
</span><a href="SDL.GPU.C.RendererControls.html#getActiveRendererList"><span class="hs-identifier hs-var">GPU.getActiveRendererList</span></a></span><span>
</span><span id="line-31"></span><span>
</span><span id="line-32"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#getCurrentRenderer"><span class="hs-identifier hs-type">getCurrentRenderer</span></a></span><span>
</span><span id="line-33"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190737"><span class="annot"><a href="#local-6989586621679190737"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-34"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190737"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-35"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190737"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Renderer"><span class="hs-identifier hs-type">GPU.Renderer</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-36"></span><span id="getCurrentRenderer"><span class="annot"><span class="annottext">getCurrentRenderer :: forall (m :: * -&gt; *). MonadIO m =&gt; m (Ptr Renderer)
</span><a href="SDL.GPU.Simple.RendererControls.html#getCurrentRenderer"><span class="hs-identifier hs-var hs-var">getCurrentRenderer</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO (Ptr Renderer)
</span><a href="SDL.GPU.C.RendererControls.html#getCurrentRenderer"><span class="hs-identifier hs-var">GPU.getCurrentRenderer</span></a></span><span>
</span><span id="line-37"></span><span>
</span><span id="line-38"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#setCurrentRenderer"><span class="hs-identifier hs-type">setCurrentRenderer</span></a></span><span>
</span><span id="line-39"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190683"><span class="annot"><a href="#local-6989586621679190683"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-40"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190683"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-41"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#RendererID"><span class="hs-identifier hs-type">GPU.RendererID</span></a></span><span>
</span><span id="line-42"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190683"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-43"></span><span id="setCurrentRenderer"><span class="annot"><span class="annottext">setCurrentRenderer :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr RendererID -&gt; m ()
</span><a href="SDL.GPU.Simple.RendererControls.html#setCurrentRenderer"><span class="hs-identifier hs-var hs-var">setCurrentRenderer</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr RendererID -&gt; IO ()
</span><a href="SDL.GPU.C.RendererControls.html#setCurrentRenderer"><span class="hs-identifier hs-var">GPU.setCurrentRenderer</span></a></span><span>
</span><span id="line-44"></span><span>
</span><span id="line-45"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#getRenderer"><span class="hs-identifier hs-type">getRenderer</span></a></span><span>
</span><span id="line-46"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190733"><span class="annot"><a href="#local-6989586621679190733"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-47"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190733"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-48"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#RendererID"><span class="hs-identifier hs-type">GPU.RendererID</span></a></span><span>
</span><span id="line-49"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190733"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Renderer"><span class="hs-identifier hs-type">GPU.Renderer</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-50"></span><span id="getRenderer"><span class="annot"><span class="annottext">getRenderer :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr RendererID -&gt; m (Ptr Renderer)
</span><a href="SDL.GPU.Simple.RendererControls.html#getRenderer"><span class="hs-identifier hs-var hs-var">getRenderer</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr RendererID -&gt; IO (Ptr Renderer)
</span><a href="SDL.GPU.C.RendererControls.html#getRenderer"><span class="hs-identifier hs-var">GPU.getRenderer</span></a></span><span>
</span><span id="line-51"></span><span>
</span><span id="line-52"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#freeRenderer"><span class="hs-identifier hs-type">freeRenderer</span></a></span><span>
</span><span id="line-53"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190731"><span class="annot"><a href="#local-6989586621679190731"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-54"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190731"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-55"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Renderer"><span class="hs-identifier hs-type">GPU.Renderer</span></a></span><span>
</span><span id="line-56"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190731"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-57"></span><span id="freeRenderer"><span class="annot"><span class="annottext">freeRenderer :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Renderer -&gt; m ()
</span><a href="SDL.GPU.Simple.RendererControls.html#freeRenderer"><span class="hs-identifier hs-var hs-var">freeRenderer</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Renderer -&gt; IO ()
</span><a href="SDL.GPU.C.RendererControls.html#freeRenderer"><span class="hs-identifier hs-var">GPU.freeRenderer</span></a></span><span>
</span><span id="line-58"></span><span>
</span><span id="line-59"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#resetRendererState"><span class="hs-identifier hs-type">resetRendererState</span></a></span><span>
</span><span id="line-60"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190729"><span class="annot"><a href="#local-6989586621679190729"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-61"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190729"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-62"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190729"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-63"></span><span id="resetRendererState"><span class="annot"><span class="annottext">resetRendererState :: forall (m :: * -&gt; *). MonadIO m =&gt; m ()
</span><a href="SDL.GPU.Simple.RendererControls.html#resetRendererState"><span class="hs-identifier hs-var hs-var">resetRendererState</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO ()
</span><a href="SDL.GPU.C.RendererControls.html#resetRendererState"><span class="hs-identifier hs-var">GPU.resetRendererState</span></a></span><span>
</span><span id="line-64"></span><span>
</span><span id="line-65"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#setCoordinateMode"><span class="hs-identifier hs-type">setCoordinateMode</span></a></span><span>
</span><span id="line-66"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190727"><span class="annot"><a href="#local-6989586621679190727"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-67"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190727"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-68"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Bool.html#Bool"><span class="hs-identifier hs-type">GPU.Bool</span></a></span><span> </span><span class="hs-comment">-- ^ use_math_coords</span><span>
</span><span id="line-69"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190727"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-70"></span><span id="setCoordinateMode"><span class="annot"><span class="annottext">setCoordinateMode :: forall (m :: * -&gt; *). MonadIO m =&gt; Bool -&gt; m ()
</span><a href="SDL.GPU.Simple.RendererControls.html#setCoordinateMode"><span class="hs-identifier hs-var hs-var">setCoordinateMode</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; IO ()
</span><a href="SDL.GPU.C.RendererControls.html#setCoordinateMode"><span class="hs-identifier hs-var">GPU.setCoordinateMode</span></a></span><span>
</span><span id="line-71"></span><span>
</span><span id="line-72"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#getCoordinateMode"><span class="hs-identifier hs-type">getCoordinateMode</span></a></span><span>
</span><span id="line-73"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190724"><span class="annot"><a href="#local-6989586621679190724"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-74"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190724"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-75"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190724"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="SDL.GPU.C.Bool.html#Bool"><span class="hs-identifier hs-type">GPU.Bool</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-comment">-- ^ use_math_coords</span><span>
</span><span id="line-76"></span><span id="getCoordinateMode"><span class="annot"><span class="annottext">getCoordinateMode :: forall (m :: * -&gt; *). MonadIO m =&gt; m Bool
</span><a href="SDL.GPU.Simple.RendererControls.html#getCoordinateMode"><span class="hs-identifier hs-var hs-var">getCoordinateMode</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">IO Bool
</span><a href="SDL.GPU.C.RendererControls.html#getCoordinateMode"><span class="hs-identifier hs-var">GPU.getCoordinateMode</span></a></span><span>
</span><span id="line-77"></span><span>
</span><span id="line-78"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#setDefaultAnchor"><span class="hs-identifier hs-type">setDefaultAnchor</span></a></span><span>
</span><span id="line-79"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190722"><span class="annot"><a href="#local-6989586621679190722"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-80"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190722"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-81"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ anchor_x</span><span>
</span><span id="line-82"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ anchor_y</span><span>
</span><span id="line-83"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190722"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-84"></span><span id="setDefaultAnchor"><span class="annot"><span class="annottext">setDefaultAnchor :: forall (m :: * -&gt; *). MonadIO m =&gt; Float -&gt; Float -&gt; m ()
</span><a href="SDL.GPU.Simple.RendererControls.html#setDefaultAnchor"><span class="hs-identifier hs-var hs-var">setDefaultAnchor</span></a></span></span><span> </span><span id="local-6989586621679190656"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190656"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span id="local-6989586621679190655"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190655"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Float -&gt; Float -&gt; IO ()
</span><a href="SDL.GPU.C.RendererControls.html#setDefaultAnchor"><span class="hs-identifier hs-var">GPU.setDefaultAnchor</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190656"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679190655"><span class="hs-identifier hs-var">y</span></a></span><span>
</span><span id="line-85"></span><span>
</span><span id="line-86"></span><span class="annot"><a href="SDL.GPU.Simple.RendererControls.html#getDefaultAnchor"><span class="hs-identifier hs-type">getDefaultAnchor</span></a></span><span>
</span><span id="line-87"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679190716"><span class="annot"><a href="#local-6989586621679190716"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-88"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679190716"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-89"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679190716"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V2</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-90"></span><span id="getDefaultAnchor"><span class="annot"><span class="annottext">getDefaultAnchor :: forall (m :: * -&gt; *). MonadIO m =&gt; m (V2 Float)
</span><a href="SDL.GPU.Simple.RendererControls.html#getDefaultAnchor"><span class="hs-identifier hs-var hs-var">getDefaultAnchor</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">alloca</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190638"><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679190638"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">alloca</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679190637"><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679190637"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-91"></span><span>  </span><span class="annot"><span class="annottext">Ptr Float -&gt; Ptr Float -&gt; IO ()
</span><a href="SDL.GPU.C.RendererControls.html#getDefaultAnchor"><span class="hs-identifier hs-var">GPU.getDefaultAnchor</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679190638"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679190638"><span class="hs-identifier hs-var">x</span></a></span><span>
</span><span id="line-92"></span><span>  </span><span class="annot"><span class="annottext">forall a. a -&gt; a -&gt; V2 a
</span><span class="hs-identifier hs-var">V2</span></span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Ptr a -&gt; IO a
</span><span class="hs-identifier hs-var">peek</span></span><span> </span><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679190638"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Applicative f =&gt; f (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;*&gt;</span></span><span> </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Ptr a -&gt; IO a
</span><span class="hs-identifier hs-var">peek</span></span><span> </span><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679190637"><span class="hs-identifier hs-var">y</span></a></span><span>
</span><span id="line-93"></span></pre></body></html>